<?php

/**
 * @version      1.0.11 24.07.2012
 * @author       MAXXmarketing GmbH
 * @package      Jshopping Auction
 * @copyright    Copyright (C) 2012 webdesigner-profi.de. All rights reserved.
 * @license      GNU/GPL
 */
defined('_JEXEC') or die('Restricted access');

class plgJshoppingCheckoutAcymailing_newsletter extends JPlugin {

    function __construct(&$subject, $config) {
        parent::__construct($subject, $config);
        JSFactory::loadExtLanguageFile('addon_acymailing_newsletter');
        define('NO_SUBSCRIPTION', 0);
        define('UNSUBSCRIBED', -1);
        define('WAIT_CONFIRMATION', 2);
        define('SUBSCRIBED', 1);
    }

    function _getSubscriberWithMail($user_email) {
        $db = JFactory::getDBO();
        $query = "SELECT *
                    FROM `#__acym_user`
                    WHERE `email`='" . $db->escape($user_email) . "' LIMIT 1";
        $db->setQuery($query);
        return $db->LoadObject();
    }

    function _getAcyUser($adv_user, $user) {
        $acy_user = new stdclass();
        if ($user->id) {
            $acy_user->email = $user->email;
            $acy_user->name = $user->username;
        } else {
            $acy_user->email = $adv_user->email;
            $acy_user->name = $adv_user->f_name;
        }
        return $acy_user;
    }

    function _getListStatusForSubscriber($acymailingUserId) {
        $db = JFactory::getDBO();
        $listid = $this->params->get('listid', 1);
        $query = 'SELECT `status`
                    FROM `#__acym_user_has_list`
                    WHERE `user_id`=' . (int) $acymailingUserId . ' AND `list_id`=' . (int) $listid . ' LIMIT 1';
        $db->setQuery($query);
        return $db->LoadResult();
    }

    function _checkUserInAcymailing($acymailingUserId) {
        $status = self::_getListStatusForSubscriber($acymailingUserId);
        if (($status == SUBSCRIBED) || ($status == WAIT_CONFIRMATION))
            return true;
        return false;
    }

    function _addSubscriber($user) {
        $db = JFactory::getDBO();
        $query = "INSERT INTO `#__acym_user` (`email`, `cms_id`, `name`, `creation_date`, `confirmed`, `active`) VALUES ( 
					'" . $db->escape($user->email) . "', 0, '" . $db->escape($user->name) . "', NOW(), 1, 1);";
        $db->setQuery($query);
        $db->query();
        return $db->insertid();
    }

    function _addStatusForSubscriber($acymailingUserId, $status) {
        $db = JFactory::getDBO();
        $listid = $this->params->get('listid', 1);
        $query = "INSERT INTO `#__acym_user_has_list`(`list_id`,`user_id`,`subscription_date`,`status`)VALUES('".$listid."','".$acymailingUserId."','".time()."','".$status."');";
        $db->setQuery($query);
        return $db->query();
    }
    
    function _getStatusForSubscriber($acy_user) {
        $db = JFactory::getDBO();
        $query = 'SELECT * FROM `#__acym_user` WHERE `email`="'.$acy_user->email.'"';
        $db->setQuery($query);
        return $db->loadObject()->id;
    }
    
    function _updateStatusForSubscriber($acymailingUserId, $status) {
        $db = JFactory::getDBO();
        $listid = (int)$this->params->get('listid', 1);
        $unsubscribeDate = '';
        if($status == UNSUBSCRIBED){
            $unsubscribeDate = ', `unsubscribe_date`=' . time();
        }
        $query = 'UPDATE `#__acym_user_has_list` SET `status`='.$status.$unsubscribeDate.' WHERE `list_id`='.$listid.' AND `user_id`='.$acymailingUserId;
        $db->setQuery($query);
        return $db->query();
    }

    function _setStatusInAcyMailing($acymailing_subscribe, $acy_user) {
        $subscriber = self::_getSubscriberWithMail($acy_user->email);
        if (is_object($subscriber) && ($subscriber->id)) {
            $status = self::_getListStatusForSubscriber($subscriber->id);
            if ($acymailing_subscribe) {
                if ($status == NO_SUBSCRIPTION) {
                    self::_addStatusForSubscriber($subscriber->id, SUBSCRIBED);
                    return 1;
                } elseif ($status == UNSUBSCRIBED) {
                    self::_updateStatusForSubscriber($subscriber->id, SUBSCRIBED);
                    return 1;
                }
            } else {
                if (($status == WAIT_CONFIRMATION) || ($status == SUBSCRIBED)) {
                    self::_updateStatusForSubscriber($subscriber->id, UNSUBSCRIBED);
                    return 1;
                }
            }
        } else {
            $status = self::_getListStatusForSubscriber($subscriber->id);
            if ($acymailing_subscribe) {
                $acymailingUserId = self::_addSubscriber($acy_user);
                self::_addStatusForSubscriber($acymailingUserId, SUBSCRIBED);
                return 1;
            }
        }
    }

    function _showCheckboxWithCheckingStatus($tmp_var_name, &$view) {
        if (!isset($view->$tmp_var_name))
            $view->$tmp_var_name = '';
        $subscriber = self::_getSubscriberWithMail($view->user->email);
        if (is_object($subscriber) && ($subscriber->id)) {
            $checked = (self::_checkUserInAcymailing($subscriber->id)) ? ' checked="checked"' : '';
        } else {
            $checked = '';
        }
        $view->$tmp_var_name .= '<tr><td class="name">' . _JSHOP_ACYMAILING_SUBSCRIBE . '</td><td><input type="checkbox" name="acymailing_subscribe" value="1"' . $checked . '/></td></tr>';
    }

    function onBeforeDisplayCheckoutStep2View(&$view) {
        self::_showCheckboxWithCheckingStatus('_tmpl_address_html_4', $view);
    }

    function onAfterSaveCheckoutStep2(&$adv_user, &$user, &$cart) {
        $post = JRequest::get('post');
        $acymailing_subscribe = (isset($post['acymailing_subscribe']) && ($post['acymailing_subscribe'] == 1)) ? 1 : 0;
        $acy_user = self::_getAcyUser($adv_user, $user);
        self::_setStatusInAcyMailing($acymailing_subscribe, $acy_user);
    }

    function onBeforeDisplayRegisterView(&$view) {
        $registration_default = (int) $this->params->get('registration_default', 0);
        $checked = $registration_default ? ' checked="checked"' : '';
        if (!isset($view->_tmpl_register_html_5))
            $view->_tmpl_register_html_5 = '';
        $view->_tmpl_register_html_5 .= '<div class = "jshop_register"><table><tr><td class="name">' . _JSHOP_ACYMAILING_SUBSCRIBE . '</td><td><input type="checkbox" name="acymailing_subscribe" value="1"' . $checked . '/></td></tr></table></div>';
    }

    function onAfterRegister(&$user, &$row, &$post, &$useractivation) {
        $acymailing_subscribe = (isset($post['acymailing_subscribe']) && ($post['acymailing_subscribe'] == 1)) ? 1 : 0;
        $acy_user = new stdclass();
        $acy_user->email = $user->email;
        $acy_user->name = $user->username;
        self::_setStatusInAcyMailing($acymailing_subscribe, $acy_user);
    }

    function onBeforeDisplayEditAccountView(&$view) {
        self::_showCheckboxWithCheckingStatus('_tmpl_editaccount_html_4', $view);
    }

    function onAfterAccountSave() {
        $user = JFactory::getUser();
        $post = JRequest::get('post');
        $acymailing_subscribe = (isset($post['acymailing_subscribe']) && ($post['acymailing_subscribe'] == 1)) ? 1 : 0;
        $acy_user = new stdclass();
        $acy_user->email = $user->email;
        $acy_user->name = $user->f_name;
        self::_setStatusInAcyMailing($acymailing_subscribe, $acy_user);
    }

    public function onBeforeCreateTemplateOrderMail(&$view) {
        $this->beforeSendEmail($view);
    }

    public function onBeforeCreateTemplateOrderPartMail(&$view) {
        $this->beforeSendEmail($view);
    }

    public function beforeSendEmail($view) {
        $user = JSFactory::getUser();

        $user_info = $this->_getSubscriberWithMail($user->email);
        $status = $this->_getListStatusForSubscriber($user_info->id);

        if ($status == 1) {
            $html = '<table width="794px" align="center" border="0" cellspacing="0" cellpadding="0" style="line-height:100%;">
                        <tr valign="top">
                            <td colspan = "2" style="padding-bottom:10px; padding-top:30px;"> 
                                ' . _JSHOP_ACYMAILING_SUBSCRIBE . '
                            </td>
			</tr>
                    </table>';
        }

        $view->_tmp_ext_html_ordermail_end .= $html;
    }

}
